entry main.enter;

import "../IMPORT/register.h";
import "../IMPORT/callsys.h";
import "../IMPORT/proc.h";
import "../IMPORT/callsys.lib.s";
import "../IMPORT/string.lib.s";
import "../IMPORT/number.lib.s";
import "../IMPORT/io.lib.s";

//	#include <stdio.h>
//	#define TRUE 1
//	#define FALSE 0
//	
//	/*
//	Convert string to lower case
//	*/
//	void toLower( char *s ) {
//		while ( *s != '\0' ) {
//			if ( 'A' <= *s && *s <= 'Z' )
//				*s = *s + 'a' - 'A';
//			s++;
//			}
//		}
//	
block toLower uses register{
	abs {
		s = a0;
	}
	code
	{
		public enter:
		{
			while:
				ldbu	$t0, ($s);
				beq		$t0, end;
			do:				
				{
					if:
						//cmplt	$t0, 'A', $t1;
						//blbs	$t1, end;
						ldiq	$t1, 'A';
						cmple	$t1, $t0, $t1;
						blbc	$t1, end;
						
						cmple	$t0, 'Z', $t1;
						blbc	$t1, end;
					then:
						addq	$t0, 'a';
						subq	$t0, 'A';
						stb		$t0, ($s);
					end:
				}
				addq $s, 1;
				br while;			
			end:
		}
		return:
			ret;
	}
}

//	/*
//	Find the index of the first occurrence of c in s
//	or -1, if it doesnt exist.
//	*/
//	
//	int findCharIndex( char c, char *s ) {
//		int i;
//		for ( i = 0; s[ i ] != '\0'; i++ )
//			if ( s[ i ] == c )
//				return i;
//		return -1;
//		}
//	
block findCharIndex uses register{
	abs
	{
		c = a0;
		s = a1;
		i = a2;
	}
	code
	{
		public enter:
			{			
				for:
				
				while:
				
				do:
							
				continue:
					
					br while;
				end:		
			}	
			negq 1, $v0;
		return:
			ret;			
	}	
}

//	/* 
//	Return TRUE if s starts with substring, otherwise return FALSE
//	*/
//	int startsWith( char *s, char *substring ) {
//		while ( *substring != '\0' ) {
//			if ( *s != *substring )
//				return FALSE;
//			s++;
//			substring++;
//			}
//		return TRUE;
//		}
//	
block startsWith uses register {
	abs {
		s			=	a0;
		substring	=	a1;
		}
	code {
		public enter:
			{
				//finish the while statement
			}
			ldiq	$v0,	1;
		return:
			ret;
		}
	}
	
//	/*
//	Find the address of the first occurrence of 
//	substring in s, return the address, or 0 if it does not occur.
//	*/
//	char *findSubstring( char *s, char *substring ) {
//		while ( *s != '\0' ) {
//			if ( startsWith( s, substring ) )
//				return s;
//			s++;
//			}
//		return NULL;
//		}
//		
block findSubstring uses proc {
	abs {
		s			=	s0;
		substring	=	s1;
		}
	code {
		public enter:
			lda		$sp,	-sav2($sp);
			stq		$ra,	savRet($sp);
			stq		$s0,	sav0($sp);
			stq		$s1,	sav1($sp);
		decls:
			mov		$a0,	$s;
			mov		$a1,	$substring;
		body:
			{
			
			//finish the while statement. Note here you are going to use function startsWith
			
			}
			clr		$v0;
		return:
			ldq		$s1,	sav1($sp);
			ldq		$s0,	sav0($sp);
			ldq		$ra,	savRet($sp);
			lda		$sp,	+sav2($sp);
			ret;
		}
	}
	
block main uses proc{
	abs{
		STRINGSIZE=10;
	}

	const{
		align quad;
	apple:
		asciiz	"apple";

		align quad;
	orange:
		asciiz	"orange";

		align quad;
	appleorange:
		asciiz	"apple and orange";

		align quad;
	formatint:
		asciiz	"%d\n";
	}

	data{
		align quad;
		input: byte[STRINGSIZE+1];
	}
	
	code{
		public enter:
			{
			/*
			testToLower:
				loop:
					//read the input string
					ldiq	$a0, input;
					ldiq	$a1, STRINGSIZE; 
					bsr		IO.readLine.enter;
					
					//lower string
					ldiq	$a0, input;
					bsr		toLower.enter;
					
					//print the lower case string
					ldiq	$a0, input;
					bsr		IO.print.enter;
					bsr		IO.newline.enter;
					br		loop;
				end:
			*/
			testFindCharIndex:
				ldiq	$a0,	'l';
				ldiq	$a1,	apple;
				bsr		findCharIndex.enter;
				ldiq	$a0,	formatint;
				mov		$v0,	$a1;
				bsr		IO.printf.enter;
			
			testStartsWith:
				ldiq	$a0,	appleorange;
				ldiq	$a1,	apple;
				bsr		startsWith.enter;
				ldiq	$a0,	formatint;
				mov		$v0,	$a1;
				bsr		IO.printf.enter;
				
			testFindSubstring:
				ldiq	$a0,	appleorange;
				ldiq	$a1,	apple;
				bsr		findSubstring.enter;
				ldbu	$a0,	($v0);
				bsr		Sys.putChar.enter;
			}
			
	}	
}
